<!-- Links in /docs/documentation should NOT have \`.md\` at the end, because they end up in our wiki at release. -->

# ng generate app-shell

## Overview
Create an app shell.

## Options
<details>
  <summary>dry-run</summary>
  <p>
    <code>--dry-run</code> (alias: <code>-d</code>)
  </p>
  <p>
    Run through without making any changes.
  </p>
</details>
<details>
  <summary>force</summary>
  <p>
    <code>--force</code> (alias: <code>-f</code>)
  </p>
  <p>
    Forces overwriting of files.
  </p>
</details>
<details>
  <summary>client-project</summary>
  <p>
    <code>--client-project</code>
  </p>
  <p>
    Name of related client app.
  </p>
</details>
<details>
  <summary>universal-project</summary>
  <p>
    <code>--universal-project</code>
  </p>
  <p>
    Name of related universal app.
  </p>
</details>
<details>
  <summary>route</summary>
  <p>
    <code>--route</code>
  </p>
  <p>
    Route path used to produce the app shell.
  </p>
</details>
<details>
  <summary>name</summary>
  <p>
    <code>--name</code>
  </p>
  <p>
    Name of the universal app
  </p>
</details>
<details>
  <summary>app-id</summary>
  <p>
    <code>--app-id</code>
  </p>
  <p>
    The appId to use withServerTransition.
  </p>
</details>
<details>
  <summary>out-dir</summary>
  <p>
    <code>--out-dir</code>
  </p>
  <p>
    The output directory for build results.
  </p>
</details>
<details>
  <summary>root</summary>
  <p>
    <code>--root</code>
  </p>
  <p>
    The root directory of the app.
  </p>
</details>
<details>
  <summary>index</summary>
  <p>
    <code>--index</code>
  </p>
  <p>
    Name of the index file
  </p>
</details>
<details>
  <summary>main</summary>
  <p>
    <code>--main</code>
  </p>
  <p>
    The name of the main entry-point file.
  </p>
</details>
<details>
  <summary>test</summary>
  <p>
    <code>--test</code>
  </p>
  <p>
    The name of the test entry-point file.
  </p>
</details>
<details>
  <summary>tsconfig-file-name</summary>
  <p>
    <code>--tsconfig-file-name</code>
  </p>
  <p>
    The name of the TypeScript configuration file.
  </p>
</details>
<details>
  <summary>test-tsconfig-file-name</summary>
  <p>
    <code>--test-tsconfig-file-name</code>
  </p>
  <p>
    The name of the TypeScript configuration file for tests.
  </p>
</details>
<details>
  <summary>app-dir</summary>
  <p>
    <code>--app-dir</code>
  </p>
  <p>
    The name of the application directory.
  </p>
</details>
<details>
  <summary>root-module-file-name</summary>
  <p>
    <code>--root-module-file-name</code>
  </p>
  <p>
    The name of the root module file
  </p>
</details>
<details>
  <summary>root-module-class-name</summary>
  <p>
    <code>--root-module-class-name</code>
  </p>
  <p>
    The name of the root module class.
  </p>
</details>
<details>
  <summary>source-dir</summary>
  <p>
    <code>--source-dir</code> (alias: <code>-D</code>)
  </p>
  <p>
    The path of the source directory.
  </p>
</details>
