<!-- Links in /docs/documentation should NOT have `.md` at the end, because they end up in our wiki at release. -->

# ng generate component

## Overview
`ng generate component [name]` generates a component

## Options
<details>
  <summary>dry-run</summary>
  <p>
    <code>--dry-run</code> (alias: <code>-d</code>)
  </p>
  <p>
    Run through without making any changes.
  </p>
</details>
<details>
  <summary>force</summary>
  <p>
    <code>--force</code> (alias: <code>-f</code>)
  </p>
  <p>
    Forces overwriting of files.
  </p>
</details>
<details>
  <summary>project</summary>
  <p>
    <code>--project</code>
  </p>
  <p>
    The name of the project.
  </p>
</details>
<details>
  <summary>inline-style</summary>
  <p>
    <code>--inline-style</code> (alias: <code>-s</code>)
  </p>
  <p>
    Specifies if the style will be in the ts file.
  </p>
</details>
<details>
  <summary>inline-template</summary>
  <p>
    <code>--inline-template</code> (alias: <code>-t</code>)
  </p>
  <p>
    Specifies if the template will be in the ts file.
  </p>
</details>
<details>
  <summary>view-encapsulation</summary>
  <p>
    <code>--view-encapsulation</code> (alias: <code>-v</code>)
  </p>
  <p>
    Specifies the view encapsulation strategy.
  </p>
</details>
<details>
  <summary>change-detection</summary>
  <p>
    <code>--change-detection</code> (alias: <code>-c</code>)
  </p>
  <p>
    Specifies the change detection strategy.
  </p>
</details>
<details>
  <summary>prefix</summary>
  <p>
    <code>--prefix</code> (alias: <code>-p</code>)
  </p>
  <p>
    The prefix to apply to generated selectors.
  </p>
</details>
<details>
  <summary>styleext</summary>
  <p>
    <code>--styleext</code>
  </p>
  <p>
    The file extension to be used for style files.
  </p>
</details>
<details>
  <summary>spec</summary>
  <p>
    <code>--spec</code>
  </p>
  <p>
    Specifies if a spec file is generated.
  </p>
</details>
<details>
  <summary>flat</summary>
  <p>
    <code>--flat</code>
  </p>
  <p>
    Flag to indicate if a dir is created.
  </p>
</details>
<details>
  <summary>skip-import</summary>
  <p>
    <code>--skip-import</code>
  </p>
  <p>
    Flag to skip the module import.
  </p>
</details>
<details>
  <summary>selector</summary>
  <p>
    <code>--selector</code>
  </p>
  <p>
    The selector to use for the component.
  </p>
</details>
<details>
  <summary>module</summary>
  <p>
    <code>--module</code> (alias: <code>-m</code>)
  </p>
  <p>
    Allows specification of the declaring module.
  </p>
</details>
<details>
  <summary>export</summary>
  <p>
    <code>--export</code>
  </p>
  <p>
    Specifies if declaring module exports the component.
  </p>
</details>
